/*
  small program that does the equivalent of

  table(apply(data!=0,1,sum))

 */


#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <sys/stat.h>
#define LENS 100000

#define VAR ".var"
#define SFS ".unfolded"

double *norm(size_t *ary,int len){
  double *ret = new double[len];
  double mySum =0;
  for(int i=0;i<len;i++)
    mySum += ary[i];

  for(int i=0;i<len;i++)
    ret[i] = ary[i]/mySum;
  return ret;
}



int fexists(const char* str){///@param str Filename given as a string.
  struct stat buffer ;
  return (stat(str, &buffer )==0 ); /// @return Function returns 1 if file exists.
}


FILE *getFILE(const char*fname,const char* mode){
  int writeFile = 0;
  for(size_t i=0;i<strlen(mode);i++)
    if(mode[i]=='w')
      writeFile = 1;
  if(0&&writeFile&&fexists(fname)){//DRAGON
    fprintf(stderr,"\t-> File exists: %s exiting...\n",fname);
    exit(0);
  }
  FILE *fp;
  if(NULL==(fp=fopen(fname,mode))){
    fprintf(stderr,"\t->Error opening FILE handle for file:%s exiting\n",fname);
    exit(0);
  }
  fprintf(stderr,"\t-> opening filehandle for: %s\n",fname);
  return fp;
}


char *append(const char* a,const char *b){
  char *c = new char[strlen(a)+strlen(b)+1];
  strcpy(c,a);
  strncat(c,b,strlen(b));
  return c;
}



int main(int argc,char **argv){
  int nChr = 0;
  FILE *fp = NULL;
  FILE *varFile = NULL;
  FILE *sfsFile = NULL;
  int argPos = 1;

  while(argPos <argc) {
    if(strcmp(argv[argPos],"-nChr")==0)
      nChr  = atoi(argv[argPos+1])+1;
    else if(strcmp(argv[argPos],"-infile")==0){
      fp = getFILE(argv[argPos+1],"r");
      varFile = getFILE(append(argv[argPos+1],VAR),"w");
      sfsFile = getFILE(append(argv[argPos+1],SFS),"w");
    }else 
      printf("\tUnknown arguments: %s\n",argv[argPos]);
    argPos+=2;
  }
  
  if(fp==NULL||nChr==0){
    fprintf(stderr,"Must supply -infile (.geno) and -nChr\n");
    return 0;
  }
  
  if(!(nChr%2) ){
    fprintf(stderr,"\t-> Number of chromosomes must be a multipla of 2\n");
    return 0;
  }
  size_t hits[nChr];
    

  memset(hits,0,sizeof(size_t)*nChr);

  const char *delims = "\t\n ";
  char *buffer = new char[LENS];
  while(fgets(buffer,LENS,fp)){
    int diff =0;
    if(atoi(strtok(buffer,delims)))
      diff++;
    char *tok;
    while((tok=strtok(NULL,delims)))
      if(atoi(tok))
	diff++;
    hits[diff]++;
    if(diff==0)
      fprintf(varFile,"0");
    else
      fprintf(varFile,"1");
  }
  if(1){
  for(int i=0;i<nChr;i++)
    fprintf(sfsFile,"%lu\t",hits[i]);
  fprintf(sfsFile,"\n");
  }


  double *normed = norm(hits,nChr);
  for(int i=0;i<nChr;i++)
    fprintf(sfsFile,"%f\t",normed[i]);
  fprintf(sfsFile,"\n");
      
  delete normed;
  delete buffer;
  return 0;
}
